"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addValue = exports.addChainId = exports.addFrom = exports.toEvmAddrString = exports.unusedArbiterFee = exports.unusedNonce = void 0;
const connect_sdk_1 = require("@wormhole-foundation/connect-sdk");
const address_1 = require("./address");
(0, connect_sdk_1.registerNative)('Evm', address_1.EvmAddress);
exports.unusedNonce = 0;
exports.unusedArbiterFee = 0n;
const toEvmAddrString = (addr) => typeof addr === 'string'
    ? addr
    : (addr instanceof connect_sdk_1.UniversalAddress ? addr.toNative('Evm') : addr).unwrap();
exports.toEvmAddrString = toEvmAddrString;
const addFrom = (txReq, from) => ({
    ...txReq,
    from,
});
exports.addFrom = addFrom;
const addChainId = (txReq, chainId) => ({
    ...txReq,
    chainId,
});
exports.addChainId = addChainId;
const addValue = (txReq, value) => ({
    ...txReq,
    value,
});
exports.addValue = addValue;
//# sourceMappingURL=types.js.map