import { ChainName, TokenId, TxHash, SignedTx, Network, PlatformToChains } from '@wormhole-foundation/connect-sdk';
import { Provider } from 'ethers';
import { EvmPlatform } from './platform';
/**
 * @category EVM
 */
export declare module EvmUtils {
    function nativeTokenId(chain: ChainName): TokenId;
    function isSupportedChain(chain: ChainName): boolean;
    function isNativeTokenId(chain: ChainName, tokenId: TokenId): boolean;
    function getDecimals(chain: ChainName, rpc: Provider, tokenId: TokenId | 'native'): Promise<bigint>;
    function getBalance(chain: ChainName, rpc: Provider, walletAddr: string, tokenId: TokenId | 'native'): Promise<bigint | null>;
    function sendWait(chain: ChainName, rpc: Provider, stxns: SignedTx[]): Promise<TxHash[]>;
    function getCurrentBlock(rpc: Provider): Promise<number>;
    function chainFromRpc(rpc: Provider): Promise<[Network, PlatformToChains<EvmPlatform.Type>]>;
}
//# sourceMappingURL=platformUtils.d.ts.map