import { ChainAddress, AutomaticCircleBridge, TokenId, Network } from '@wormhole-foundation/connect-sdk';
import { EvmChainName, UniversalOrEvm } from '../types';
import { EvmUnsignedTransaction } from '../unsignedTransaction';
import { CircleRelayer } from '../ethers-contracts';
import { Provider } from 'ethers';
import { EvmContracts } from '../contracts';
export declare class EvmAutomaticCircleBridge implements AutomaticCircleBridge<'Evm'> {
    readonly network: Network;
    readonly chain: EvmChainName;
    readonly provider: Provider;
    readonly contracts: EvmContracts;
    readonly circleRelayer: CircleRelayer;
    readonly chainId: bigint;
    private constructor();
    static fromProvider(provider: Provider, contracts: EvmContracts): Promise<EvmAutomaticCircleBridge>;
    transfer(token: TokenId, sender: UniversalOrEvm, recipient: ChainAddress, amount: bigint, nativeGas?: bigint): AsyncGenerator<EvmUnsignedTransaction>;
    private createUnsignedTx;
}
//# sourceMappingURL=automaticCircleBridge.d.ts.map