import { ChainAddress, UniversalOrNative, AutomaticTokenBridge, VAA, TokenId, Network } from '@wormhole-foundation/connect-sdk';
import { Provider } from 'ethers';
import { EvmChainName, UniversalOrEvm } from '../types';
import { EvmUnsignedTransaction } from '../unsignedTransaction';
import { TokenBridgeRelayer } from '../ethers-contracts';
import { EvmContracts } from '../contracts';
export declare class EvmAutomaticTokenBridge implements AutomaticTokenBridge<'Evm'> {
    readonly network: Network;
    readonly chain: EvmChainName;
    readonly provider: Provider;
    readonly contracts: EvmContracts;
    readonly tokenBridgeRelayer: TokenBridgeRelayer;
    readonly chainId: bigint;
    private constructor();
    redeem(sender: UniversalOrNative<'Evm'>, vaa: VAA<'TransferWithPayload'>): AsyncGenerator<EvmUnsignedTransaction>;
    static fromProvider(provider: Provider, contracts: EvmContracts): Promise<EvmAutomaticTokenBridge>;
    transfer(sender: UniversalOrEvm, recipient: ChainAddress, token: UniversalOrEvm | 'native', amount: bigint, relayerFee: bigint, nativeGas?: bigint): AsyncGenerator<EvmUnsignedTransaction>;
    getRelayerFee(sender: ChainAddress, recipient: ChainAddress, token: TokenId | 'native'): Promise<bigint>;
    private createUnsignedTx;
}
//# sourceMappingURL=automaticTokenBridge.d.ts.map