import { ChainAddress, CircleTransferDetails, CircleBridge, UnsignedTransaction, TokenId, Network } from '@wormhole-foundation/connect-sdk';
import { EvmChainName, UniversalOrEvm } from '../types';
import { EvmUnsignedTransaction } from '../unsignedTransaction';
import { MessageTransmitter, TokenMessenger } from '../ethers-contracts';
import { Provider } from 'ethers';
import { EvmContracts } from '../contracts';
export declare class EvmCircleBridge implements CircleBridge<'Evm'> {
    readonly network: Network;
    readonly chain: EvmChainName;
    readonly provider: Provider;
    readonly contracts: EvmContracts;
    readonly chainId: bigint;
    readonly msgTransmitter: MessageTransmitter.MessageTransmitter;
    readonly tokenMessenger: TokenMessenger.TokenMessenger;
    readonly tokenEventHash: string;
    readonly messageEventHash: string;
    private constructor();
    static fromProvider(provider: Provider, contracts: EvmContracts): Promise<EvmCircleBridge>;
    redeem(sender: UniversalOrEvm, message: string, attestation: string): AsyncGenerator<UnsignedTransaction>;
    transfer(token: TokenId, sender: UniversalOrEvm, recipient: ChainAddress, amount: bigint): AsyncGenerator<EvmUnsignedTransaction>;
    parseTransactionDetails(txid: string): Promise<CircleTransferDetails>;
    private createUnsignedTx;
}
//# sourceMappingURL=circleBridge.d.ts.map